# Last modified Information Relaying Specification(LIRS)ѥå  ver.1.02(19991122)
# Copyright (C) 1999 hiya All Rights Reserved.

# 
package LIRS;
use File::Copy 'cp';


## LIRS2list
# LIRSΰĤΥ쥳ɤϤȡLIRSǤȤ֤
# ΤȤץʥΥեɤϤޤȤ(,פޤ)֤ΤǡǤʤФʤʤ
sub LIRS2list($){
	$_ = shift;

	unless(/^#/){
		s/\\,/%2c/g;
		my ($head, $time, $lmd, $lag, $length, $url, $title, $author, $remote, $chksum) = split(",", $_, 10);
		if($chksum =~ /(\015|\012)+$/ && $head eq "LIRS"){
			$url =~ s/%7e/~/io;

			$url =~ s/%2c/\,/ig;
			$title =~ s/%2c/\,/ig;
			$author =~ s/%2c/\,/ig;
			$chksum =~ s/(.*,)(\015|\012)+$/$1/;
			$chksum =~ s/%2c/\\,/ig;
			return($time, $lmd, $lag, $length, $url, $title, $author, $remote, $chksum);
		}else{
			return undef;
		}
	}else{
		return undef;
	}
}


## list2LIRS
# LIRSν¤ϤȡLIRSΰĤΥ쥳ɤˤʤä顼ѿ֤
# ΤȤץʥΥեɤϤޤȤ(,פޤ)Τޤ޸ɵʤΤǡ餫ἫǽƤʤФʤʤ
sub list2LIRS($$$$$$$$;$){
	my ($time, $lmd, $lag, $length, $url, $title, $author, $remote, $optional) = @_;

	$lmd = 0 if($lmd eq "");
	$lag = 0 if($lag eq "");
	$length = 0 if($length eq "");
	$title = 0 if($title eq "");
	$author = 0 if($author eq "");
	$remote = 0 if($remote eq "");

	$url =~ s/,/\\,/g;
	$title =~ s/,/\\,/g;
	$author =~ s/,/\\,/g;

	$remote = "" unless($length =~ /^[\\,\#\&\%\+\.\/\:\=\?\@\w\s\~\-!<>]+$/);
	$time = "" unless($time =~ /^\d+$/);
	$lmd = "" unless($lmd =~ /^\d+$/);
	$lag = "" unless($lag =~ /^[\d\-\+]+$/);
	$length = "" unless($length =~ /\d+$/);
	$url = "" unless($length =~ /[\\,\#\&\%\+\.\/\:\=\?\@\w\s\~\-!<>]+$/);

	if($time ne ""){
		my $ret = "LIRS" . "," . $time . "," . $lmd . "," . $lag . "," . $length . "," . $url . "," . $title . "," . $author . "," . $remote . ",";
		$ret .= $optional."," if($optional ne "");
		$ret .= "\n";
		return $ret;
	}else{
		my $ret = "LIRS" . ",0,0," . $lag . "," . $length . "," . $url . "," . $title . "," . $author . "," . $remote . ",";
		$ret .= $optional."," if($optional ne "");
		$ret .= "\n";
		return $ret;
	}
}


## cLIRS($gzip, $file)
# ǻꤷLIRSե뤫顢žѤΰ̥եgzip(ǻ)Ǻޤ
# ΤȤLIRSեϤΤޤްݻޤ
# 1֤Ԥ0֤ޤ
sub cLIRS($$){
	my $gzip = shift;
	my $file = shift;

	if(-e $file){
		if(-e "$file.gz"){
			unlink("$file.gz") || die "&LIRS\'cLIRS: $!\n";
		}
		cp($file, "$file.bak") || die "&LIRS\'cLIRS: $!\n";
		system($gzip, $file, "$file.gz");
		rename("$file.bak", "$file") || die "&LIRS\'cLIRS: $!\n";

		return 1 if(-e "$file.gz" && -e $file);
	}
	return 0;
}


## xLIRS($gzip, $file)
# ǻꤷgzipǰ̤줿LIRSեgzip(ǻ)ǻȤ褦Ÿޤ
# ⤷ꤷե뤬Ǥ¸ߤȤϡ񤭤ޤ
# 0֤Ԥundef֤ޤ
sub xLIRS($$){
	my $gzip = shift;
	my $file = shift;
	my $fil = $file;

	$fil =~ s/.gz$//i;
	if(-e $fil){
		unlink("$fil") || die "&LIRS\'xLIRS: $!\n";
	}
	system($gzip, "-d", $file);
	return 1 if(-e $fil);
	return 0;
}

1;

