#!/usr/local/bin/perl
# parseLIRS.pl Copyright (C) 2000 hiya All Rights Reserved.


# 
$target = shift(@ARGV);
$options = join(',', @ARGV);


# ؤ
if($target eq "" || $target =~ /help/){
	print <<'EOF';

parseLIRS.pl Copyright (C) 2000 hiya All Rights Reserved.

usage:
  perl parseLIRS.pl [(target LIRS file) | help] {options:add, exclusive, nounix}

  target LIRS file: want to parse LIRS file(only one)
  option
      help: show help message(this)
      add: add parsed LIRS files
      exclusive: parse LIRS file exclusive setting
      nounix: no UNIX machine

EOF
	exit(0);
}


# ʥ
$SIG{'INT'} = $SIG{'BUS'} = $SIG{'HUP'} = $SIG{'QUIT'} = $SIG{'TERM'} = $SIG{'ALRM'} = 'autokill';
if($options !~ /nounix/){
	alarm(120);
}


# ϥե
# nm_lib.pljcode.plLIRS.pmɤ߹
require './nm_lib.pl';
require './LIRS.pm';
require './jcode.pl';


# ¹Գ

# եɤ߹
@dat = &nm_lib::read_file("$target");


# ե
foreach $data (@dat){
	my $lirs = (&LIRS::LIRS2list($data))[8];
	my $op = (split(",", $lirs))[3];
	my $a = 0;

	&jcode::convert(\$op, 'euc');

	if($op =~ //){
		push(@den, $data);
		$a++;
		next if($options =~ /exclusive/);

	}
	if($op =~ /(||)/){
		push(@hauN, $data);
		$a++;
		next if($options =~ /exclusive/);

	}
	if($op =~ //){
		push(@saba, $data);
		$a++;
		next if($options =~ /exclusive/);

	}
	if($op =~ //){
		push(@ichigo, $data);
		$a++;
		next if($options =~ /exclusive/);

	}
	if($op =~ /HN/){
		push(@hns, $data);
		$a++;
		next if($options =~ /exclusive/);

	}
	if($op =~ /TD/){
		push(@tds, $data);
		$a++;
		next if($options =~ /exclusive/);

	}
	if($op =~ /GN/){
		push(@gns, $data);
		$a++;
		next if($options =~ /exclusive/);

	}
	push(@z, $data) if($a == 0);

}


# 
if($options =~ /add/){
	&nm_lib::add_file("den.lirs", join('', @den));
	&nm_lib::add_file("hauN.lirs", join('', @hauN));
	&nm_lib::add_file("saba.lirs", join('', @saba));
	&nm_lib::add_file("ichigo.lirs", join('', @ichigo));
	&nm_lib::add_file("hns.lirs", join('', @hns));
	&nm_lib::add_file("tds.lirs", join('', @tds));
	&nm_lib::add_file("gns.lirs", join('', @gns));

	&nm_lib::add_file("def.lirs", join('', @z));

}else{
	&nm_lib::write_file("den.lirs", join('', @den));
	&nm_lib::write_file("hauN.lirs", join('', @hauN));
	&nm_lib::write_file("saba.lirs", join('', @saba));
	&nm_lib::write_file("ichigo.lirs", join('', @ichigo));
	&nm_lib::write_file("hns.lirs", join('', @hns));
	&nm_lib::write_file("tds.lirs", join('', @tds));
	&nm_lib::write_file("gns.lirs", join('', @gns));

	&nm_lib::write_file("def.lirs", join('', @z));

}

exit(0);



























##
# ֥롼
sub autokill{
	print STDERR "$!\012";
	exit(0);
}

1;

